uses graph,crt,zu,treu;
  const
    n=9;
    xc=230;
    yc=255;
    cs=10;
  var
    mx,my : array [0..n,0..n] of integer;
    mz    : array [0..n,0..n] of real;
    ax,ay                 : real;
    sinx,cosx,siny,cosy   : real;
    kx,ky                 : real;
    centerx,centery,i0,j0 : integer;
{***************************************}
procedure massiv;
  var
    i,j : integer;
  begin
    for i:=0 to n do
      begin
        for j:=0 to n do
          begin
            mx[i,j]:=i-(n div 2);
            my[i,j]:=j-(n div 2);
            mz[i,j]:=sin(i*j/3)+2;
          end;
      end;
  end;
{****************************************}
procedure interfais;forward;
{----------------------------}
procedure calcpallete;
  var
    t,r1,r2,g1,g2,b1,b2,r,g,b : integer;
  begin
    r1:=0;r2:=0;
    g1:=0;g2:=30;
    b1:=60;b2:=0;
      for t:=16 to 136 do
        begin
          r:=round(r1+((t-16)*(r2-r1))/(136-16));
          b:=round(b1+((t-16)*(b2-b1))/(136-16));
          g:=round(g1+((t-16)*(g2-g1))/(136-16));
          setrgbpalette(t,r,g,b);
        end;
    r1:=0;r2:=60;
    g1:=30;g2:=60;
    b1:=0;b2:=60;
      for t:=136 to 255 do
        begin
          r:=round(r1+((t-136)*(r2-r1))/(255-136));
          b:=round(b1+((t-136)*(b2-b1))/(255-136));
          g:=round(g1+((t-136)*(g2-g1))/(255-136));
          setrgbpalette(t,r,g,b);
        end;
  end;

{----------------------------}
procedure RisKva(x,y:byte);
  var
    z : real;
  begin
    z_kvad(90+25*mx[x+1,y+1],102+25*my[x+1,y+1],mz[x,y],mz[x+1,y],mz[x+1,y+1],mz[x,y+1]);
  end;
{-----------------------------}
procedure risplosk;
  var
    i,j : integer;
  begin
    for i:=0 to n-1 do
      for j:=0 to n-1 do
      riskva(i,j);
  end;
{------------------------------}
procedure redaktor;
  var
    x,y : integer;

procedure edit;
  var
    ch : char;
    p  : pointer;
  begin
    x:=n div 2;
    y:=n div 2;
    getmem(p,imagesize(0,0,10,10));
    getimage(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+10,yc+my[x,y]*50+10,p^);
    setcolor(4);
    line(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+10,yc+my[x,y]*50+10);
    line(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+5,yc+my[x,y]*50+2);
    line(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+2,yc+my[x,y]*50+5);

      REPEAT
        ch:=readkey;
        if ch=#0 then ch:=readkey;
         putimage(xc+mx[x,y]*50,yc+my[x,y]*50,p^,normalput);
          case ch of
            #75 : if x > 0 then dec(x);
            #77 : if x < n then inc(x);
            #72 : if y > 0 then dec(y);
            #80 : if y < n then inc(y);
            '-' : begin
                    mz[x,y]:=mz[x,y]-0.05;
                    if mz[x,y]<1.0 then mz[x,y]:=1.0;
                    if (x-1>=0)and(y-1>=0) then riskva(x-1,y-1);
                    if (x-1>=0)and(y<n) then    riskva(x-1,y);
                    if (x<n)and(y-1>=0) then    riskva(x,y-1);
                    if (x<n)and(y<n) then       riskva(x,y);
                  end;
            '=' : begin
                    mz[x,y]:=mz[x,y]+0.05;
                    if mz[x,y]>3 then mz[x,y]:=3;
                    if (x-1>=0)and(y-1>=0) then  riskva(x-1,y-1);
                    if (x-1>=0)and(y<n) then     riskva(x-1,y);
                    if (x<n)and(y-1>=0) then     riskva(x,y-1);
                    if (x<n)and(y<n) then        riskva(x,y);
                  end;
          end;
    getimage(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+10,yc+my[x,y]*50+10,p^);
    setcolor(4);
    line(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+10,yc+my[x,y]*50+10);
    line(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+5,yc+my[x,y]*50+2);
    line(xc+mx[x,y]*50,yc+my[x,y]*50,xc+mx[x,y]*50+2,yc+my[x,y]*50+5);
     while keypressed do
            readkey;
     UNTIL  ch=#27;
  end;
  begin
    edit;
  end;
{****************************************************************}
procedure knopka(x,y,x1,y1:integer;st:string);
  begin
    setfillstyle(solidfill,180);
    bar(x,y,x1,y1);
    setcolor(white); line(x,y,x1,y); line(x,y,x,y1);
    setcolor(black); line(x1,y1,x1,y); line(x1,y1,x,y1);
    settextjustify(centertext,centertext);
    setcolor(black);
    outtextxy((x+x1) div 2,(y+y1) div 2,st);
  end;

procedure nk(x,y,x1,y1,pr:integer);
  begin
    if pr=1 then
      begin
        setcolor(black); line(x,y,x1,y);   line(x,y,x,y1);
        setcolor(white); line(x1,y1,x1,y); line(x1,y1,x,y1);
      end;
    if pr=0 then
      begin
        setcolor(white); line(x,y,x1,y);   line(x,y,x,y1);
        setcolor(black); line(x1,y1,x1,y); line(x1,y1,x,y1);
      end;
  end;

{-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
procedure Wiew3DGraphics;
var
   x,y:integer;
{-------------------------------------------------}
function xm(x,y:integer):integer;
begin
   xm:=x*40+y*40;
end;
function ym(x,y:integer):integer;
begin
   ym:=y*12+(10-x)*12+200-round((mz[x,y]-1)*50);
end;
{-------------------------------------------------}
begin
   cleardevice;
   for x:=n-1 downto 0 do
      for y:=0 to n-1 do
      begin
         ZakTre(xm(x,y),ym(x,y),(mz[x,y]-1.8)*1.8,
                xm(x+1,y),ym(x+1,y),(mz[x+1,y]-1.8)*1.8,
                xm(x,y+1),ym(x,y+1),(mz[x,y+1]-1.8)*1.8);

         ZakTre(xm(x+1,y+1),ym(x+1,y+1),(mz[x+1,y+1]-1.8)*1.8,
                xm(x+1,y),ym(x+1,y),(mz[x+1,y]-1.8)*1.8,
                xm(x,y+1),ym(x,y+1),(mz[x,y+1]-1.8)*1.8);

      end;
   repeat
   until(keypressed);
   interfais;
   risplosk;
end;
{-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
function ReadName:string;
var
   name :array[0..7]of char;
   ch:char;
   nb,ab:byte;
begin
   name:='        ';  {8-ᨬ}
   nk(620,220,785,280,1);
   setcolor(15);
   outtextxy(628,240,'Enter the file name');
   setfillstyle(0,1);
   bar(628,250,777,270);
   nb:=0;
   repeat
      ch:=readkey;
      if((ord(ch)>=39)and(nb<=7))then
      begin
         name[nb]:=ch;
         nb:=nb+1;
      end;
      if ch=#8 then
      begin
         nb:=nb-1;
         name[nb]:=' ';
      end;
      setfillstyle(0,1);
      bar(628,250,777,270);
      outtextxy(630,265,name);

   until(ch=#13);
   setfillstyle(solidfill,208);
   bar(620,220,785,280);
   ReadName:=name;
end;
{-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
procedure Save;
var
   F:file of real;
   name:string;
    Xs,Ys:integer;
begin
   name:=ReadName;
   Assign(F, name);
   Rewrite(F);
   for Xs:=0 to n do
      for Ys:=0 to n do
      begin
         Write(F,mz[Xs,Ys]);
      end;
   Close(F);

end;
{-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
procedure Load;
var
   F:file of real;
    Xs,Ys:integer;
    name:string;
begin
   name:=ReadName;
   {$I-}
   Assign(F, name);
   reset(F);
   {$I+}
   If IORESULT <> 0 then exit;
   for Xs:=0 to n do
      for Ys:=0 to n do
      begin
         read(F,mz[Xs,Ys]);
      end;
   Close(F);
   RisPlosk;

end;
{-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}
procedure New;
var
   Xn,Yn:integer;
   Zn:integer;
   ch:char;
begin
   Zn:=120;
   repeat
      setcolor(0);
      Line(530,30+(Zn-16)*2,600,30+(Zn-16)*2);
      ch:=readkey;
      setcolor(256-Zn);
      Line(530,30+(Zn-16)*2,600,30+(Zn-16)*2);
      if ch=#0 then
      begin
         ch:=readkey;
         case ch of
            #80 : if Zn<240 then Zn:=Zn+1;
            #72 : if Zn>16 then Zn:=Zn-1;
         end;
      end;
   until((ch=#13)or(ch=#27));

   if(ch=#13)then
   begin
      for Xn:=0 to n do
         for Yn:=0 to n do
            mz[Xn,Yn]:=3-(Zn-16)/224*2;
      RisPlosk;
   end;
end;
{-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=}

procedure obrklav;
  const
    xk1 : array [1..6] of integer = (10,70,130,190,250,310);
    xk2 : array [1..6] of integer = (60,120,180,240,300,360);
  var
    ch    : char;
    i,x,y : integer;
  begin
    i:=3;
      repeat
        ch:=readkey;
          if ch=#0 then ch:=readkey;
          nk(xk1[i],540,xk2[i],570,0);
            case ch of
              #75 : if i>1 then dec(i);
              #77 : if i<6 then inc(i);
            end;
          nk(xk1[i],540,xk2[i],570,1);
          if ch=#13 then
            case i of
              1 : redaktor;
              2 : Wiew3DGraphics;
              3 : Load;
              4 : Save;
              5 : New;
            end;
      until ((i=6) and (ch=#13));
  end;


procedure about;
  begin
    settextstyle(defaultfont,horizdir,1);
    nk(620,30,790,200,1);
    nk(620+3,30+3,790-3,200-3,0);
    settextjustify(0,0);
    outtextxy(630,65,'     LANDSEAPE');
    outtextxy(630,95,' By Kiryanova A.ZU.');
    outtextxy(630,125,'   Gr.604B1 @1998');
    outtextxy(630,155,'      HCI NSU.');
  end;
{***********************************************************}
procedure interfais;
  var
    i,j,k : integer;
  begin
    setfillstyle(solidfill,208);
     bar(0,0,getmaxx,getmaxy);
    setfillstyle(solidfill,0);
     bar(10,30,510,530);
    setcolor(15);
     line(510,30,510,530);
    setcolor(15);
     line(10,530,510,530);
    setcolor(15);
     line(0,0,0,getmaxy);
    setcolor(15);
     line(0,0,getmaxx,0);
      for j:=16 to 240 do
        begin
          setcolor(256-j);
          rectangle(530,30+(j-16)*2,600,30+(j-16)*2+1);
        end;
    knopka(10,540,60,570, 'Edit');

    knopka(70,540,120,570,'Show');

    knopka(130,540,180,570,'Load');

    knopka(190,540,240,570,'Save');

    knopka(250,540,300,570,'New');

    knopka(310,540,360,570,'Exit');

    about;
  end;
{******************************************************}
procedure init;
  var
    gd,gm : integer;
  begin
    gd:=installuserdriver('svga256',nil);
    gm:=3;
    initgraph(gd,gm,'h:\bp\bgi');
  end;

{*******************************************************}
BEGIN
  init;
  kx:=getmaxx/240.0;
  ky:=getmaxy/180.0;
  centerx:=240;
  centery:=250;
  ax:=45/180*pi;
  ay:=45/180*pi;
  calcpallete;
  interfais;
  massiv;
  nk(130,540,180,570,1);
  risplosk;
  obrklav;
  closegraph;
END.